# Generated by the gRPC Python protocol compiler plugin. DO NOT EDIT!
"""Client and server classes corresponding to protobuf-defined services."""

import grpc
import warnings

import rag_pb2 as rag__pb2

GRPC_GENERATED_VERSION = "1.65.5"
GRPC_VERSION = grpc.__version__
EXPECTED_ERROR_RELEASE = "1.66.0"
SCHEDULED_RELEASE_DATE = "August 6, 2024"
_version_not_supported = False

try:
    from grpc._utilities import first_version_is_lower

    _version_not_supported = first_version_is_lower(
        GRPC_VERSION, GRPC_GENERATED_VERSION
    )
except ImportError:
    _version_not_supported = True

if _version_not_supported:
    warnings.warn(
        f"The grpc package installed is at version {GRPC_VERSION},"
        + f" but the generated code in rag_pb2_grpc.py depends on"
        + f" grpcio>={GRPC_GENERATED_VERSION}."
        + f" Please upgrade your grpc module to grpcio>={GRPC_GENERATED_VERSION}"
        + f" or downgrade your generated code using grpcio-tools<={GRPC_VERSION}."
        + f" This warning will become an error in {EXPECTED_ERROR_RELEASE},"
        + f" scheduled for release on {SCHEDULED_RELEASE_DATE}.",
        RuntimeWarning,
    )


class RAGServiceStub(object):
    """Missing associated documentation comment in .proto file."""

    def __init__(self, channel):
        """Constructor.

        Args:
            channel: A grpc.Channel.
        """
        self.instruct_llm_query = channel.unary_stream(
            "/RAGService/instruct_llm_query",
            request_serializer=rag__pb2.Empty.SerializeToString,
            response_deserializer=rag__pb2.LLMQuery.FromString,
            _registered_method=True,
        )
        self.retrieve_llm_response = channel.stream_unary(
            "/RAGService/retrieve_llm_response",
            request_serializer=rag__pb2.LLMAnswer.SerializeToString,
            response_deserializer=rag__pb2.Status.FromString,
            _registered_method=True,
        )


class RAGServiceServicer(object):
    """Missing associated documentation comment in .proto file."""

    def instruct_llm_query(self, request, context):
        """Missing associated documentation comment in .proto file."""
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details("Method not implemented!")
        raise NotImplementedError("Method not implemented!")

    def retrieve_llm_response(self, request_iterator, context):
        """Missing associated documentation comment in .proto file."""
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details("Method not implemented!")
        raise NotImplementedError("Method not implemented!")


def add_RAGServiceServicer_to_server(servicer, server):
    rpc_method_handlers = {
        "instruct_llm_query": grpc.unary_stream_rpc_method_handler(
            servicer.instruct_llm_query,
            request_deserializer=rag__pb2.Empty.FromString,
            response_serializer=rag__pb2.LLMQuery.SerializeToString,
        ),
        "retrieve_llm_response": grpc.stream_unary_rpc_method_handler(
            servicer.retrieve_llm_response,
            request_deserializer=rag__pb2.LLMAnswer.FromString,
            response_serializer=rag__pb2.Status.SerializeToString,
        ),
    }
    generic_handler = grpc.method_handlers_generic_handler(
        "RAGService", rpc_method_handlers
    )
    server.add_generic_rpc_handlers((generic_handler,))
    server.add_registered_method_handlers("RAGService", rpc_method_handlers)


# This class is part of an EXPERIMENTAL API.
class RAGService(object):
    """Missing associated documentation comment in .proto file."""

    @staticmethod
    def instruct_llm_query(
        request,
        target,
        options=(),
        channel_credentials=None,
        call_credentials=None,
        insecure=False,
        compression=None,
        wait_for_ready=None,
        timeout=None,
        metadata=None,
    ):
        return grpc.experimental.unary_stream(
            request,
            target,
            "/RAGService/instruct_llm_query",
            rag__pb2.Empty.SerializeToString,
            rag__pb2.LLMQuery.FromString,
            options,
            channel_credentials,
            insecure,
            call_credentials,
            compression,
            wait_for_ready,
            timeout,
            metadata,
            _registered_method=True,
        )

    @staticmethod
    def retrieve_llm_response(
        request_iterator,
        target,
        options=(),
        channel_credentials=None,
        call_credentials=None,
        insecure=False,
        compression=None,
        wait_for_ready=None,
        timeout=None,
        metadata=None,
    ):
        return grpc.experimental.stream_unary(
            request_iterator,
            target,
            "/RAGService/retrieve_llm_response",
            rag__pb2.LLMAnswer.SerializeToString,
            rag__pb2.Status.FromString,
            options,
            channel_credentials,
            insecure,
            call_credentials,
            compression,
            wait_for_ready,
            timeout,
            metadata,
            _registered_method=True,
        )
